/******************************* Prototyp-Definition ************************/

int   Read_Int(char *String, int Default, char Buchstabe);
float Read_Float(char *String, float Default, char Buchstabe);
void  Read_String(char Kommentar[],char String[]);
char  Read_Char(char *String, char Value);
void  ShowError(char *Message);
void  Geduld(void);
void  Swap(int *P1, int *P2);
char  Upper(char c);
int   Add_Extension(char FileName[], char *Ext);
void  WriteText(int X_Pos, int Y_Pos, char *Text);
void  WriteInt(int Zahl);
void  WriteFloat(float Zahl);
void  ClearTextWindow(int X_Left, int Y_Left, int X_Right, int Y_Right);

void  PlotPixel(long Spalte, long Zeile, unsigned char Farbe);
void  Graph_Mode(void);
void  Text_Mode(void);
void  Set_LUT(void);
void  Make_Icon(int BildNr);
void  Show_Icon(int BildNr);
void  Show_Pic(int BildNr, int Position);

void  Init_Var(void);

void  Read_Save_Menue(void);
int   Read_PCX_Picture(void);
int   Save_PCX_Picture(void);
void  Swap_Picture(int BildNr1, int BildNr2);
void  Copy_Picture(int BildNr1, int BildNr2);
void  Test_Bild(int Art);

void  Edge_Menue(void);
void  Roberts(int BildNr1, int BildNr2);
void  Sobel(int BildNr1, int BildNr2);
void  Prewitt(int BildNr1, int BildNr2);
void  Laplace(int BildNr1, int BildNr2);
void  Edge_Mask(void);
void  Marr_Hildreth(int BildNr1, int BildNr2, int Radius, float Sigma);

void  Histogramm_Menue(void);
void  Grauwertmanipu(int Art, int BildNr, float Faktor_Schwelle);
void  Binaerbild(int BildNr, int Schwelle);
void  Histogramm(int BildNr1, int BildNr2);
void  Intens_Skalier(int BildNr);
void  Skalier_Histo(int BildNr, int Prozent);
void  Adapt_Histo(int BildNr1, int BildNr2, int Fenster);

void  Geometrie_Menue(void);
void  Skalierung(void);
void  Rotation(void);
void  Ausschnitt(void);
void  Spiegelung(void);
void  Pic_Info(void);
void  Mittelpunkt(void);

void  Glaettungs_Menue(void);
void  Mittelwert(int BildNr1, int BildNr2, int Groesse);
void  Median_MxN(int BildNr1, int BildNr2, int Groesse_M, int Groesse_N);
int   Median_Wert(unsigned char Pixelvektor[], int Pixelzahl, int Median_Pos);
void  Median(int BildNr1, int BildNr2, int Form, int Groesse);

void  Mehrbild_Menue(void);
void  BildBild(int Funktion);

void  Morphol_Menue(void);
void  Scan_Line_Thin(int BildNr, int Richtung);
void  Thinning_LW(int BildNr);
void  Thinning_Ji(int BildNr);
unsigned char Code(long BildOffset, int Spaltenzahl, long z, long s, unsigned char Muster[]);
void  Erosion(int BildNr1, int BildNr2, int Schwelle);
void  Dilatation(int BildNr1, int BildNr2, int Schwelle);

void  Transform_Menue(void);
void  DFT_1Dim(int Zeilen_Richtung, int Nummer);
void  Histo_darst(int BildNr, int Anzahl, float Histogramm_Werte[], int Shift);
void  FFT(int Filterung);
void  FFT_1Dim(int Vorwaerts_Trafo, int Anzahl, int ld_Anzahl, float Dat_Real[], float Dat_Imag[]);
void  DCT(int Filterung);

void  Divers_Menue(void);
void  Gamma(int BildNr, float Gamma);
void  Rauschen(int BildNr, int Prozent);
void  EdgeEnhance(int BildNr1, int BildNr2);
void  Textur_Coocc(int BildNr1, int BildNr2);

void  Save_VGA(void);
int   GetPixel(long z, long s);

